﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using YSUtils.Data;

namespace UnitTest
{
    /// <summary>
    ///This is a test class for DataFolderTest and is intended
    ///to contain all DataFolderTest Unit Tests
    ///</summary>
	[TestClass]
	public class DataFolderTest
	{
		#region Constants

		/// <summary>
		/// End of the folder path.
		/// </summary>
    	private const string EndOfPath = @"\AppData\Roaming\StulSoft\YSUtils";
		#endregion

		/// <summary>
		///Gets or sets the test context which provides
		///information about and functionality for the current test run.
		///</summary>
		public TestContext TestContext
		{
			get; set;
		}

		#region Additional test attributes
		// 
		//You can use the following additional attributes as you write your tests:
		//
		//Use ClassInitialize to run code before running the first test in the class
		//[ClassInitialize()]
		//public static void MyClassInitialize(TestContext testContext)
		//{
		//}
		//
		//Use ClassCleanup to run code after all tests in a class have run
		//[ClassCleanup()]
		//public static void MyClassCleanup()
		//{
		//}
		//
		//Use TestInitialize to run code before running each test
		//[TestInitialize()]
		//public void MyTestInitialize()
		//{
		//}
		//
		//Use TestCleanup to run code after each test has run
		//[TestCleanup()]
		//public void MyTestCleanup()
		//{
		//}
		//
		#endregion

		/// <summary>
		///A test for GetApplicationDataFolder
		///</summary>
		[TestMethod]
		public void GetApplicationDataFolderTest()
		{
			const string expected = EndOfPath;
			var actual = DataFolder.GetApplicationDataFolder();
			Assert.IsTrue(actual.EndsWith(expected), "GetApplicationDataFolder failed.");
		}

		/// <summary>
		///A test for GetApplicationDataFileName
		///</summary>
		[TestMethod]
		public void GetApplicationDataFileNameTest()
		{
			const string fileName = "test.txt";
			const string expected = EndOfPath + @"\test.txt";
			var actual = DataFolder.GetApplicationDataFileName(fileName);
			Assert.IsTrue(actual.EndsWith(expected), "GetApplicationDataFileNameTest failed.");
		}

		/// <summary>
		///A test for CreateApplicationDataFolder
		///</summary>
		[TestMethod]
		public void CreateApplicationDataFolderTest()
		{
			const string expected = EndOfPath;
			var actual = DataFolder.CreateApplicationDataFolder();
			Assert.IsTrue(actual.EndsWith(expected), "CreateApplicationDataFolderTest failed.");
		}
	}
}
